## net.sf.saxon.expr
Class ArithmeticExpression10

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.BinaryExpression
              net.sf.saxon.expr.ArithmeticExpression10

All Implemented Interfaces:
  Serializable, SourceLocator, Container, EvaluableItem, SequenceIterable, InstructionInfoProvider

    public class ArithmeticExpression10

extends BinaryExpression

Arithmetic Expression: an expression using one of the operators plus, minus, multiply, div, idiv, mod, in backwards compatibility mode: see `ArithmeticExpression` for the non-backwards compatible case.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`ArithmeticExpression10(Expression p1, int operator, Expression p2)`

Method Summary
`Item` `evaluateItem(XPathContext context)` Evaluate the expression.
`ItemType` `getItemType(TypeHierarchy th)` Determine the data type of the expression, if this is known statically
`boolean` `isBackwardsCompatible()` Determine whether the expression is to be evaluated in backwards-compatible mode
`Expression` `typeCheck(StaticContext env, ItemType contextItemType)` Type-check the expression statically.

Methods inherited from class net.sf.saxon.expr.BinaryExpression
`computeCardinality, computeSpecialProperties, display, equals, getOperands, getOperator, hashCode, iterateSubExpressions, optimize, promote, replaceSubExpression, simplify`

Methods inherited from class net.sf.saxon.expr.Expression

`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, effectiveBooleanValue, evaluateAsString, getCardinality, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getInstructionInfo, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, iterate, markTailFunctionCalls, process, resetStaticProperties, setLocationId, setParentExpression, setParentExpression, suppressValidation`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ArithmeticExpression10

    public ArithmeticExpression10(Expression p1,
                                  int operator,
                                  Expression p2)

Method Detail

### isBackwardsCompatible

    public boolean isBackwardsCompatible()

  Determine whether the expression is to be evaluated in backwards-compatible mode

### typeCheck

    public Expression typeCheck(StaticContext env,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression statically. We try to work out which particular arithmetic function to use if the types of operands are known an compile time.

  Overrides:
    `typeCheck` in class `BinaryExpression`
  Parameters:
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the data type of the expression, if this is known statically

  Specified by:
    `getItemType` in class `Expression`
  Parameters:
    `th` -
  Returns:
    a value such as Type.STRING, Type.BOOLEAN, Type.NUMBER, Type.NODE, or Type.ITEM (meaning not known at compile time)

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate the expression.

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

Copyright (C) Michael H. Kay. All rights reserved.